// ReCo Remote Contact Transmitter (ATTiny2313 8MHz)
// V2 - Copyleft furrtek 2012

#define BTN_ARM PD2
#define BTN_FIRE PD3
#define LED_RED PD5
#define RADIO PB6

#define TIMECONST 1500

#include <avr/io.h>
#include <util/delay.h>

void RadioSend(uint32_t data) {
	uint8_t bits;

	for (bits=0;bits<32;bits++) {
		PORTB = _BV(RADIO);
		if ((data<<bits)&0x80000000) {
			_delay_us(TIMECONST*3);
		} else {
			_delay_us(TIMECONST);
		}
		PORTB = 0;
		_delay_us(TIMECONST);
	}
}

int main(void) {
	uint8_t hello;

	WDTCSR |= (1<<WDCE) | (1<<WDE);	// Watchdog off
	WDTCSR = 0x00;

	DDRB = _BV(RADIO);
	DDRD = _BV(LED_RED);
	PORTD = _BV(BTN_ARM) | _BV(BTN_FIRE);

	for (hello=0;hello<10;hello++) {
		PORTD |= _BV(LED_RED);
		_delay_ms(100);
		PORTD &= ~_BV(LED_RED);
		_delay_ms(100);
	}

	while (1) {
		if (!bit_is_set(PIND, BTN_ARM)) {
			PORTD |= _BV(LED_RED);
			RadioSend(0x0FEE1BAD);
			_delay_ms(100);
			while(!bit_is_set(PIND, BTN_ARM)) {}
			_delay_ms(100);
			PORTD &= ~_BV(LED_RED);
		}
		if (!bit_is_set(PIND, BTN_FIRE)) {
			PORTD |= _BV(LED_RED);
			RadioSend(0xDEADBEEF);
			_delay_ms(100);
			while(!bit_is_set(PIND, BTN_FIRE)) {}
			_delay_ms(100);
			PORTD &= ~_BV(LED_RED);
		}
	}
	return 0;
}
